/*
 * Created on 2005/03/28
 */
package net.asukaze.anxious;

import java.awt.BorderLayout;
import java.awt.FileDialog;
import java.awt.Font;
import java.awt.event.KeyEvent;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.reflect.Method;
import java.util.Iterator;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JLabel;

import javax.swing.JScrollPane;

/**
 * @author asukaze
 */
public class MainForm extends JFrame {
	private Manager manager = null;
	private Problem problem = null;
	private boolean failed = false;
	private OptionDialog optionDialog = null;
	private int hintType = HINT_1CHAR;
	public static final int HINT_NONE = -1;
	public static final int HINT_1CHAR = 0;
	public static final int HINT_DOTALL = 1;
	public static final int HINT_DOTSPACE = 2;
	
	private javax.swing.JPanel jContentPane = null;
	private javax.swing.JMenuBar jJMenuBar = null;
	private javax.swing.JMenu fileMenu = null;
	private javax.swing.JMenu optionMenu = null;
	private javax.swing.JMenu helpMenu = null;
	private javax.swing.JMenuItem exitMenuItem = null;
	private javax.swing.JMenuItem aboutMenuItem = null;
	private javax.swing.JMenuItem openMenuItem = null;
	private javax.swing.JMenuItem openReversalMenuItem = null;
	private javax.swing.JMenuItem goBackMenuItem = null;
	private javax.swing.JMenuItem goNextMenuItem = null;
	private javax.swing.JMenuItem optionMenuItem = null;
	private JPanel jAnswerPanel = null;
	private JTextArea taQuestion = null;
	private JTextField txtAnswer = null;
	private JLabel lblLogo = null;
	private JButton btnOK = null;
	private JScrollPane jScrollPane = null;
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJAnswerPanel() {
		if (jAnswerPanel == null) {
			lblLogo = new JLabel();
			jAnswerPanel = new JPanel();
			lblLogo.setText("AnxiousJ " + Manager.getVersion());
			jAnswerPanel.setLayout(new BorderLayout());
			jAnswerPanel.add(getTxtAnswer(), BorderLayout.NORTH);
			jAnswerPanel.add(lblLogo, BorderLayout.WEST);
			jAnswerPanel.add(getBtnOK(), BorderLayout.EAST);
		}
		return jAnswerPanel;
	}
	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */    
	private JTextArea getTaQuestion() {
		if (taQuestion == null) {
			taQuestion = new JTextArea();
			taQuestion.setEditable(false);
			taQuestion.setLineWrap(true);
		}
		return taQuestion;
	}
	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getTxtAnswer() {
		if (txtAnswer == null) {
			txtAnswer = new JTextField();
			txtAnswer.addKeyListener(new java.awt.event.KeyAdapter() {   
				public void keyPressed(java.awt.event.KeyEvent e) {    
					if(e.getKeyCode() == KeyEvent.VK_ENTER){
						checkAnswer();
					}
				} 
			});
		}
		return txtAnswer;
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getBtnOK() {
		if (btnOK == null) {
			btnOK = new JButton();
			btnOK.setText("OK");
			btnOK.setEnabled(false);
			btnOK.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					checkAnswer();
				}
			});
		}
		return btnOK;
	}
	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */    
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getTaQuestion());
		}
		return jScrollPane;
	}
    public static void main(String[] args) {
		MainForm application = new MainForm();
		application.show();
	}
	/**
	 * This is the default constructor
	 */
	public MainForm() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
		this.setJMenuBar(getJJMenuBar());
		this.setSize(300,200);
		this.setContentPane(getJContentPane());
		this.setTitle("AnxiousJ");
		this.addWindowListener(new java.awt.event.WindowAdapter() {   
			public void windowOpened(java.awt.event.WindowEvent e) {    
				try{
					new Configure(MainForm.this).read();
				}catch(Exception exc){}
			}   
			public void windowClosing(java.awt.event.WindowEvent e) {    
				try{
					new Configure(MainForm.this).write();
				}catch(Exception exc){}
			}
		});
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if(jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.add(getJScrollPane(), java.awt.BorderLayout.CENTER);
			jContentPane.add(getJAnswerPanel(), java.awt.BorderLayout.SOUTH);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jJMenuBar	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */    
	private javax.swing.JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new javax.swing.JMenuBar();
			jJMenuBar.add(getFileMenu());
			jJMenuBar.add(getOptionMenu());
			jJMenuBar.add(getHelpMenu());
		}
		return jJMenuBar;
	}
	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private javax.swing.JMenu getFileMenu() {
		if (fileMenu == null) {
			fileMenu = new javax.swing.JMenu();
			fileMenu.setText("File");
			fileMenu.add(getOpenMenuItem());
			fileMenu.add(getOpenReversalMenuItem());
			fileMenu.addSeparator();
			fileMenu.add(getGoBackMenuItem());
			fileMenu.add(getGoNextMenuItem());
			fileMenu.addMenuListener(new javax.swing.event.MenuListener() { 
				public void menuSelected(javax.swing.event.MenuEvent e) {    
					if(manager == null){
						getGoBackMenuItem().setEnabled(false);
						getGoNextMenuItem().setEnabled(false);
					}else{
						getGoBackMenuItem().setEnabled(manager.canGoBack());
						getGoNextMenuItem().setEnabled(manager.canGoNext());
					}
				}
				public void menuCanceled(javax.swing.event.MenuEvent e) {} 
				public void menuDeselected(javax.swing.event.MenuEvent e) {
					getGoBackMenuItem().setEnabled(true);
					getGoNextMenuItem().setEnabled(true);
				} 
			});
			fileMenu.addSeparator();
			fileMenu.add(getExitMenuItem());
		}
		return fileMenu;
	}
	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private javax.swing.JMenu getOptionMenu() {
		if (optionMenu == null) {
			optionMenu = new javax.swing.JMenu();
			optionMenu.setText("Option");
			optionMenu.add(getOptionMenuItem());
		}
		return optionMenu;
	}
	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private javax.swing.JMenu getHelpMenu() {
		if (helpMenu == null) {
			helpMenu = new javax.swing.JMenu();
			helpMenu.setText("Help");
			helpMenu.add(getAboutMenuItem());
		}
		return helpMenu;
	}
	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private javax.swing.JMenuItem getExitMenuItem() {
		if (exitMenuItem == null) {
			exitMenuItem = new javax.swing.JMenuItem();
			exitMenuItem.setText("Exit");
			exitMenuItem.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					System.exit(0);
				}
			});
		}
		return exitMenuItem;
	}
	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private javax.swing.JMenuItem getAboutMenuItem() {
		if (aboutMenuItem == null) {
			aboutMenuItem = new javax.swing.JMenuItem();
			aboutMenuItem.setText("About...");
			aboutMenuItem.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					MessageBox msgbox = new MessageBox(MainForm.this);
					msgbox.setTitle("o[W");
					msgbox.setMessage("AnxiousiËL₷j\n   Ver. "  + Manager.getVersion() + "\n   by \n        " + Manager.getReleaseDate());
					msgbox.show();
				}
			});
		}
		return aboutMenuItem;
	}
	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private javax.swing.JMenuItem getOpenMenuItem() {
		if (openMenuItem == null) {
			openMenuItem = new javax.swing.JMenuItem();
			openMenuItem.setText("Open...");
			openMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.Event.CTRL_MASK, true));
			openMenuItem.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					openFile(false);
				}
			});
		}
		return openMenuItem;
	}

	private javax.swing.JMenuItem getOpenReversalMenuItem() {
		if (openReversalMenuItem == null) {
			openReversalMenuItem = new javax.swing.JMenuItem();
			openReversalMenuItem.setText("Open Reverse...");
			openReversalMenuItem.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					openFile(true);
				}
			});
		}
		return openReversalMenuItem;
	}

	private javax.swing.JMenuItem getGoBackMenuItem() {
		if (goBackMenuItem == null) {
			goBackMenuItem = new javax.swing.JMenuItem();
			goBackMenuItem.setText("Go Back");
			goBackMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Z, java.awt.Event.CTRL_MASK, true));
			goBackMenuItem.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					if((manager != null) && manager.canGoBack()){
						Problem prob = manager.goBack(problem);
						if(prob != null){
							problem = prob;
							showProblem();
						}
					}
				}
			});
		}
		return goBackMenuItem;
	}
	
	private javax.swing.JMenuItem getGoNextMenuItem() {
		if (goNextMenuItem == null) {
			goNextMenuItem = new javax.swing.JMenuItem();
			goNextMenuItem.setText("Go Next");
			goNextMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Y, java.awt.Event.CTRL_MASK, true));
			goNextMenuItem.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if((manager != null) && manager.canGoNext()){
						Problem prob = manager.goNext();
						if(prob != null){
							problem = prob;
							showProblem();
						}
					}
				}
			});
		}
		return goNextMenuItem;
	}

	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private javax.swing.JMenuItem getOptionMenuItem() {
		if (optionMenuItem == null) {
			optionMenuItem = new javax.swing.JMenuItem();
			optionMenuItem.setText("Option...");
			optionMenuItem.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					getOptionDialog().show();
				}
			});
		}
		return optionMenuItem;
	}

	private OptionDialog getOptionDialog(){
		if(optionDialog == null){
			optionDialog = new OptionDialog(this);
			optionDialog.setModal(true);
		}
		return optionDialog;
	}
	
	public int getHintType(){
		return hintType;
	}
	
	public void setHintType(int hintType){
		this.hintType = hintType;
	}
	
	public void setFont(Font font){
		taQuestion.setFont(font);
		txtAnswer.setFont(font);
		lblLogo.setFont(font);
		btnOK.setFont(font);
		super.setFont(font);
	}

	public void setFont(String family, int size){
		setFont(new Font(family, Font.PLAIN, size));
	}
	
	void openFile(boolean reversal){
		try{
			java.io.Reader reader;
			String filename;
			try{
				Class serviceManager = Class.forName("javax.jnlp.ServiceManager");
				Method lookup = serviceManager.getMethod("lookup", new Class[]{String.class});
				Object fileOpenService = lookup.invoke(null, new String[]{"javax.jnlp.FileOpenService"});
				Method openFileDialog = fileOpenService.getClass().getMethod("openFileDialog", new Class[]{String.class, String[].class});
				Object fileContents = openFileDialog.invoke(fileOpenService, new Object[]{null, null});
	            if(fileContents == null){ return; }
	            Method getName = fileContents.getClass().getMethod("getName", new Class[]{});
				filename = getName.invoke(fileContents, new Object[]{}).toString();
	            Method getInputStream = fileContents.getClass().getMethod("getInputStream", new Class[]{});
				Object inputStream = getInputStream.invoke(fileContents, new Object[]{});
	            reader = new InputStreamReader((InputStream)inputStream);
			}catch(Exception exc){
				FileDialog openFileDialog = new FileDialog(MainForm.this, "t@CJ", FileDialog.LOAD);
				openFileDialog.show();
				filename = openFileDialog.getFile();
				if(filename == null){ return; }
				reader = new FileReader(openFileDialog.getDirectory() + filename);
			}
			manager = new Manager();
			manager.setReversal(reversal);
			BufferedReader br = new BufferedReader(reader);
			manager.OpenFile(br, filename);
			br.close();
			reader.close();
			nextProblem();
		}catch(IOException exc){
			MessageBox msgbox = new MessageBox(MainForm.this);
			msgbox.setTitle(exc.getClass().getName());
			msgbox.setMessage(exc.getLocalizedMessage());
			msgbox.show();
		}
	}
	
	void showProblem(){
		if(problem == null){ return; }
		taQuestion.setText(problem.getQuestion());
		failed = false;
		btnOK.setEnabled(true);
		txtAnswer.requestFocus();
	}
	
	void nextProblem(){
		if(manager != null && manager.isStudying()){
			this.setTitle(manager.getPercentage() + "% - " + manager.getFileName());
			lblLogo.setText("" + manager.getRemainingCount() + "");
			problem = manager.nextProblem();
			if(problem != null){
				showProblem();
			}else{
				StringBuffer sb = new StringBuffer();
				sb.append("SII\r\nꂳ܂łB\r\n\r\n");
				Iterator it = manager.getGoodCounter().iterator();
				for(int i=1; it.hasNext(); i++){
					sb.append(i + "ڂŐ:\t" + it.next() + "\r\n");
				}
				taQuestion.setText(sb.toString());
				btnOK.setEnabled(false);
			}
		}
	}

	void checkAnswer(){
		if(problem == null){ return; }
		String answer = txtAnswer.getText();
		String correct = problem.getCorrectAnswerFor(answer);
		if(answer.equals(correct)){
			manager.solved(problem, failed);
			nextProblem();
			txtAnswer.setText("");
		}else{
			failed = true;
			int len = Manager.hitLength(answer, correct);
			len++;
			String hint;
			if(hintType == HINT_NONE){
				hint = "";
			}else if(len >= correct.length()){
				hint = "(" + correct + ")";
			}else if(hintType == HINT_1CHAR){
				hint = "(" + correct.substring(0,len) + "...)";
			}else{
				StringBuffer sb = new StringBuffer();
				sb.append(correct.substring(0,len));
				for(int i=len; i<correct.length(); i++){
					if(hintType == HINT_DOTSPACE && correct.charAt(i) == ' '){
						sb.append(" ");
					}else{
						sb.append(".");
					}
				}
				hint = "(" +  sb.toString() + ")";
			}
			taQuestion.setText(problem.getQuestion() + "\r\n" + hint);
		}
	}
}
