/*
 * Created on 2005/03/29
 */
package net.asukaze.anxious;

import java.awt.Component;

import javax.swing.*;

import org.eclipse.swt.widgets.Shell;

/**
 * @author asukaze
 */
public class MessageBox {
	Component parentComponent;
	Shell parentShell;
	String title;
	String message;
	
	public MessageBox(Component parent){
		parentComponent = parent;
		parentShell = null;
	}

	public MessageBox(Shell parent){
		parentComponent = null;
		parentShell = parent;
	}

	public void setTitle(String title){
		this.title = title;
	}
	
	public void setMessage(String message){
		this.message = message;
	}
	
	public void show(){
		if(parentComponent != null){
			JOptionPane pane = new JOptionPane();
			pane.setMessage(message);
			JDialog dialog = pane.createDialog(parentComponent, title);
			dialog.show();
		}else if(parentShell != null){
			org.eclipse.swt.widgets.MessageBox msgbox
				= new org.eclipse.swt.widgets.MessageBox(parentShell);
			msgbox.setText(title);
			msgbox.setMessage(message);
			msgbox.open();
		}
	}
	
	public static void show(Component parent, String message, String title){
		MessageBox msgbox = new MessageBox(parent);
		msgbox.setMessage(message);
		msgbox.setTitle(title);
		msgbox.show();
	}
}
