/*
 * Created on 2005/03/29
 */
package net.asukaze.anxious;

import javax.swing.JDialog;

import javax.swing.JTabbedPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.awt.GridLayout;

import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JSpinner;
import javax.swing.JButton;
import javax.swing.SpinnerNumberModel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * @author asukaze
 */
public class OptionDialog extends JDialog {
	private MainForm parent = null;
	private Font orgfont = null;
	private int orghinttype = 0;
	
	private javax.swing.JPanel jContentPane = null;
	private JTabbedPane jTabbedPane = null;
	private JPanel pnlHint = null;
	private JPanel pnlView = null;
	private JRadioButton rbHintNone = null;
	private JRadioButton rbHint1 = null;
	private JRadioButton rbHintDot = null;
	private JRadioButton rbHintDotSpace = null;
	private JLabel lblFont = null;
	private JComboBox cbFontFamily = null;
	private JSpinner spinFontSize = null;
	private JLabel lblStyle = null;
	private JPanel pnlFont = null;
	private JPanel pnlLookFeel = null;
	private JPanel pnlButtons = null;
	private JButton btnOK = null;
	private JButton btnCancel = null;
	private JLabel lblPt = null;
	private JComboBox cbLookFeel = null;
	/**
	 * This is the default constructor
	 */
	public OptionDialog() {
		super();
		initialize();
	}

	public OptionDialog(MainForm parentForm) {
		super(parentForm);
		this.parent = parentForm;
		initialize();
	}
	
	public void show(){
		storeCurrentData();
		selectCurrentHintType();
		selectCurrentFont();
		selectLookAndFeelRadioButton();
		if(parent != null){
			setFont(parent.getFont().getFamily());
		}
		super.show();
	}
	
	public void setFont(String family){
		setFont(new Font(family, Font.PLAIN, 12));
	}
	public void setFont(Font font){
		jTabbedPane.setFont(font);
		rbHintNone.setFont(font);
		rbHint1.setFont(font);
		rbHintDot.setFont(font);
		rbHintDotSpace.setFont(font);
		lblFont.setFont(font);
		cbFontFamily.setFont(font);
		spinFontSize.setFont(font);
		lblPt.setFont(font);
		lblStyle.setFont(font);
		cbLookFeel.setFont(font);
		btnOK.setFont(font);
		btnCancel.setFont(font);
		super.setFont(font);
		pack();
	}
	
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setTitle("Option");
		this.setSize(300, 235);
		this.setContentPane(getJContentPane());
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if(jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.add(getJTabbedPane(), java.awt.BorderLayout.CENTER);
			jContentPane.add(getPnlButtons(), java.awt.BorderLayout.SOUTH);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jTabbedPane	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */    
	private JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.addTab("Hint", null, getPnlHint(), null);
			jTabbedPane.addTab("View", null, getPnlView(), null);
		}
		return jTabbedPane;
	}
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getPnlHint() {
		if (pnlHint == null) {
			GridLayout gridLayout1 = new GridLayout();
			pnlHint = new JPanel();
			pnlHint.setLayout(gridLayout1);
			gridLayout1.setColumns(1);
			gridLayout1.setRows(4);
			pnlHint.add(getRbHintNone(), null);
			pnlHint.add(getRbHint1(), null);
			pnlHint.add(getRbHintDot(), null);
			pnlHint.add(getRbHintDotSpace(), null);
		}
		return pnlHint;
	}
	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getPnlView() {
		if (pnlView == null) {
			lblFont = new JLabel();
			lblStyle = new JLabel();
			GridLayout gridLayout11 = new GridLayout();
			pnlView = new JPanel();
			pnlView.setLayout(gridLayout11);
			lblFont.setText("Font");
			lblStyle.setText("Look&Feel");
			gridLayout11.setRows(4);
			gridLayout11.setColumns(1);
			pnlView.add(lblFont, null);
			pnlView.add(getPnlFont(), null);
			pnlView.add(lblStyle, null);
			pnlView.add(getPnlLookFeel(), null);
		}
		return pnlView;
	}
	/**
	 * This method initializes jRadioButton	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */    
	private JRadioButton getRbHintNone() {
		if (rbHintNone == null) {
			rbHintNone = new JRadioButton();
			rbHintNone.setText("qg\Ȃ");
			rbHintNone.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeHintType(MainForm.HINT_NONE);
				}
			});
		}
		return rbHintNone;
	}
	/**
	 * This method initializes jRadioButton1	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */    
	private JRadioButton getRbHint1() {
		if (rbHint1 == null) {
			rbHint1 = new JRadioButton();
			rbHint1.setText("𕔕+1\");
			rbHint1.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeHintType(MainForm.HINT_1CHAR);
				}
			});
		}
		return rbHint1;
	}
	/**
	 * This method initializes jRadioButton2	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */    
	private JRadioButton getRbHintDot() {
		if (rbHintDot == null) {
			rbHintDot = new JRadioButton();
			rbHintDot.setText("u.v\");
			rbHintDot.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeHintType(MainForm.HINT_DOTALL);
				}
			});
		}
		return rbHintDot;
	}
	/**
	 * This method initializes jRadioButton3	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */    
	private JRadioButton getRbHintDotSpace() {
		if (rbHintDotSpace == null) {
			rbHintDotSpace = new JRadioButton();
			rbHintDotSpace.setText("Xy[XȊOɁu.v\");
			rbHintDotSpace.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeHintType(MainForm.HINT_DOTSPACE);
				}
			});
		}
		return rbHintDotSpace;
	}
	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getCbFontFamily() {
		if (cbFontFamily == null) {
			cbFontFamily = new JComboBox();
			cbFontFamily.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeFont();
				}
			});
		}
		return cbFontFamily;
	}
	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JSpinner getSpinFontSize() {
		if (spinFontSize == null) {
			spinFontSize = new JSpinner();
			spinFontSize.setModel(new SpinnerNumberModel(8, 8, 72, 1));
			spinFontSize.addChangeListener(new ChangeListener(){
				public void stateChanged(ChangeEvent e){
					changeFont();
				}
			});
		}
		return spinFontSize;
	}
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getPnlFont() {
		if (pnlFont == null) {
			lblPt = new JLabel();
			pnlFont = new JPanel();
			lblPt.setText("pt");
			pnlFont.add(getCbFontFamily(), null);
			pnlFont.add(getSpinFontSize(), null);
			pnlFont.add(lblPt, null);
		}
		return pnlFont;
	}
	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getPnlLookFeel() {
		if (pnlLookFeel == null) {
			pnlLookFeel = new JPanel();
			pnlLookFeel.add(getCbLookFeel(), null);
		}
		return pnlLookFeel;
	}
	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getPnlButtons() {
		if (pnlButtons == null) {
			pnlButtons = new JPanel();
			pnlButtons.add(getBtnOK(), null);
			pnlButtons.add(getBtnCancel(), null);
		}
		return pnlButtons;
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getBtnOK() {
		if (btnOK == null) {
			btnOK = new JButton();
			btnOK.setText("OK");
			btnOK.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					OptionDialog.this.dispose();
				}
			});
		}
		return btnOK;
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getBtnCancel() {
		if (btnCancel == null) {
			btnCancel = new JButton();
			btnCancel.setText("Cancel");
			btnCancel.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					restoreOriginalData();
					OptionDialog.this.dispose();
				}
			});
		}
		return btnCancel;
	}

	private void storeCurrentData(){
		if(parent != null){
			orgfont = parent.getFont();
			orghinttype = parent.getHintType();
		}
	}

	private void restoreOriginalData(){
		if(parent != null){
			parent.setFont(orgfont);
			parent.setHintType(orghinttype);
		}
	}
	
	private void selectCurrentHintType(){
		int hinttype = 0;
		if(parent != null){
			hinttype = parent.getHintType();
		}
		rbHintNone.setSelected(hinttype == MainForm.HINT_NONE);
		rbHint1.setSelected(hinttype == MainForm.HINT_1CHAR);
		rbHintDot.setSelected(hinttype == MainForm.HINT_DOTALL);
		rbHintDotSpace.setSelected(hinttype == MainForm.HINT_DOTSPACE);
	}

	private void changeHintType(int type){
		if(parent != null){
			parent.setHintType(type);
		}
		selectCurrentHintType();
	}

	private void selectCurrentFont(){
		if(cbFontFamily.getItemCount() == 0){
			cbFontFamily.setEnabled(false);
			String familyName[] = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
			for(int i=0; i<familyName.length; i++){
				cbFontFamily.addItem(familyName[i]);
			}
			cbFontFamily.setEnabled(true);
		}
		if(parent != null){
			Font font = parent.getFont();
			cbFontFamily.setSelectedItem(font.getFamily());
			spinFontSize.setValue(new Integer(font.getSize()));
		}
	}

	private void changeFont() {
		try{
			if(!cbFontFamily.isEnabled()){ return; }
			if(parent != null){
				String fontfamily = cbFontFamily.getSelectedItem().toString();
				int size = ((Integer)(spinFontSize.getValue())).intValue();
				if(size < 8) { spinFontSize.setValue(new Integer(8)); return; } 
				if(size > 72) { spinFontSize.setValue(new Integer(72)); return; } 
				parent.setFont(fontfamily, size);
			}
		}catch(Exception exc){}
	}

	private void selectLookAndFeelRadioButton(){
		if(cbLookFeel.getItemCount() == 0){
			cbLookFeel.setEnabled(false);
			UIManager.LookAndFeelInfo[] lookfeels = UIManager.getInstalledLookAndFeels();
			for(int i=0; i<lookfeels.length; i++){
				cbLookFeel.addItem(lookfeels[i].getName());
			}
			cbLookFeel.setEnabled(true);
		}
		cbLookFeel.setSelectedItem(UIManager.getLookAndFeel().getName());
	}
	
	private void changeLookAndFeel() {
		try{
			if(!cbLookFeel.isEnabled()){ return; }
			UIManager.LookAndFeelInfo[] lookfeels = UIManager.getInstalledLookAndFeels();
			String lookandfeel = null;
			for(int i=0; i<lookfeels.length; i++){
				if(lookfeels[i].getName().equals(cbLookFeel.getSelectedItem())){
					lookandfeel = lookfeels[i].getClassName();
					break;
				}
			}
			UIManager.setLookAndFeel(lookandfeel);
			SwingUtilities.updateComponentTreeUI(this);
			pack();
			if(parent != null){
				SwingUtilities.updateComponentTreeUI(parent);
			}
		}catch(Exception exc){
		}
	}
	/**
	 * This method initializes jComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getCbLookFeel() {
		if (cbLookFeel == null) {
			cbLookFeel = new JComboBox();
			cbLookFeel.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					changeLookAndFeel();
				}
			});
		}
		return cbLookFeel;
	}
 }  //  @jve:decl-index=0:visual-constraint="10,10"
