/*
 * Created on 2005/03/28
 */
package net.asukaze.anxious;

import java.io.IOException;
import java.util.Iterator;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;

import org.eclipse.swt.widgets.Text;
/**
 * @author asukaze
 */
public class SWTForm {
	private Manager manager;
	private Problem problem;
	private boolean failed;
	
	private org.eclipse.swt.widgets.Shell sShell = null;
	private Composite composite = null;
	private Text taQuestion = null;
	private Text txtAnswer = null;
	private Label lblLogo = null;
	private Label lblTimeLimit = null;
	private Button btnOK = null;
	/**
	 * This method initializes composite	
	 *
	 */    
	private void createComposite() {
		GridData gridData5 = new GridData();
		GridData gridData4 = new GridData();
		GridData gridData3 = new GridData();
		GridLayout gridLayout2 = new GridLayout();
		composite = new Composite(sShell, SWT.NONE);		   
		txtAnswer = new Text(composite, SWT.BORDER);
		lblLogo = new Label(composite, SWT.NONE);
		lblTimeLimit = new Label(composite, SWT.NONE);
		btnOK = new Button(composite, SWT.NONE);
		composite.setLayout(gridLayout2);
		gridLayout2.numColumns = 3;
		gridLayout2.makeColumnsEqualWidth = true;
		lblLogo.setText("AnxiousJ " + Manager.getVersion());
		gridData3.horizontalSpan = 3;
		gridData3.horizontalAlignment = org.eclipse.swt.layout.GridData.FILL;
		txtAnswer.setLayoutData(gridData3);
		lblTimeLimit.setText("");
		lblTimeLimit.setLayoutData(gridData5);
		gridData4.horizontalAlignment = org.eclipse.swt.layout.GridData.END;
		btnOK.setLayoutData(gridData4);
		btnOK.setText("  OK  ");
		btnOK.setEnabled(false);
		gridData5.horizontalAlignment = org.eclipse.swt.layout.GridData.CENTER;
		txtAnswer.addKeyListener(new org.eclipse.swt.events.KeyAdapter() { 
			public void keyPressed(org.eclipse.swt.events.KeyEvent e) {    
				if(e.keyCode == '\r' || e.keyCode == '\n') checkAnswer();
			}
		});
		btnOK.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() { 
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {    
				checkAnswer();
			}
		});
	}
 	public static void main(String[] args) {
		/* Before this is run, be sure to set up the following in the launch configuration 
		 * (Arguments->VM Arguments) for the correct SWT library path. 
		 * The following is a windows example:
		 * -Djava.library.path="installation_directory\plugins\org.eclipse.swt.win32_3.0.0\os\win32\x86"
		 */
		org.eclipse.swt.widgets.Display display = org.eclipse.swt.widgets.Display.getDefault();		
		SWTForm thisClass = new SWTForm();
		thisClass.createSShell() ;
		thisClass.sShell.open();
		
		while (!thisClass.sShell.isDisposed()) {
			if (!display.readAndDispatch()) display.sleep ();
		}
		display.dispose();		
	}

	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		sShell = new org.eclipse.swt.widgets.Shell();		   
		createMenu();
		createComposite();
		sShell.setText("AnxiousJ");
		sShell.setLayout(new FormLayout());
		sShell.setSize(new org.eclipse.swt.graphics.Point(300,200));

		FormData compositeData = new FormData();
		compositeData.bottom = new FormAttachment(100,0);
		compositeData.left = new FormAttachment(0,0);
		compositeData.right = new FormAttachment(100,0);
		composite.setLayoutData(compositeData);

		FormData taQuestionData = new FormData();
		taQuestion = new Text(sShell, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL);
		taQuestionData.top = new FormAttachment(0,5);
		taQuestionData.bottom = new FormAttachment(composite,-5);
		taQuestionData.left = new FormAttachment(0,5);
		taQuestionData.right = new FormAttachment(100,-5);
		taQuestion.setLayoutData(taQuestionData);
		taQuestion.setEditable(false);
	}
	
	private void createMenu(){
	    Menu menubar = new Menu(sShell,SWT.BAR);
	    sShell.setMenuBar(menubar);
	    
	    MenuItem mnFile = new MenuItem(menubar,SWT.CASCADE);
	    mnFile.setText("t@C(&F)");
	    Menu menuFile = new Menu(mnFile);
	    mnFile.setMenu(menuFile);
	    
	    MenuItem mnOpen = new MenuItem(menuFile,SWT.PUSH);
	    mnOpen.setText("J(&O)...\tCtrl+O");
		mnOpen.setAccelerator(SWT.CONTROL | 'O');
	    mnOpen.addSelectionListener(new SelectionAdapter(){
	        public void widgetSelected(SelectionEvent e){
				try{
					FileDialog openFileDialog = new FileDialog(sShell, SWT.OPEN);
					String filename = openFileDialog.open();
					if(filename == null){ return; }
					manager = new Manager();
					manager.OpenFile(null, filename);
					nextProblem();
				}catch(IOException exc){
					MessageBox msgbox = new MessageBox(sShell);
					msgbox.setTitle(exc.getClass().getName());
					msgbox.setMessage(exc.getLocalizedMessage());
					msgbox.show();
				}
	        }
	      });
		
	    MenuItem mnSep1 = new MenuItem(menuFile,SWT.SEPARATOR);
	    
	    MenuItem mnExit = new MenuItem(menuFile,SWT.PUSH);
	    mnExit.setText("I");
	    mnExit.addSelectionListener(new SelectionAdapter(){
	        public void widgetSelected(SelectionEvent e){
	        	System.exit(0);
	        }
	      });

	    MenuItem mnHelp = new MenuItem(menubar,SWT.CASCADE);
	    mnHelp.setText("wv(&H)");
	    Menu menuHelp = new Menu(mnHelp);
	    mnHelp.setMenu(menuHelp);

	    MenuItem mnAbout = new MenuItem(menuHelp,SWT.PUSH);
	    mnAbout.setText("o[W(&A)...");
	    mnAbout.addSelectionListener(new SelectionAdapter(){
	        public void widgetSelected(SelectionEvent e){
				MessageBox msgbox = new MessageBox(sShell);
				msgbox.setTitle("o[W");
				msgbox.setMessage("AnxiousiËL₷j\n   Ver. "  + Manager.getVersion() + "\n   by \n        " + Manager.getReleaseDate());
				msgbox.show();
	        }
	      });

	}
	
	void nextProblem(){
		if(manager != null && manager.isStudying()){
			sShell.setText(manager.getPercentage() + "% - " + manager.getFileName());
			lblLogo.setText("" + manager.getRemainingCount() + "");
			problem = manager.nextProblem();
			if(problem != null){
				taQuestion.setText(problem.getQuestion());
				failed = false;
				btnOK.setEnabled(true);
				txtAnswer.forceFocus();
			}else{
				StringBuffer sb = new StringBuffer();
				sb.append("SII\r\nꂳ܂łB\r\n\r\n");
				Iterator it = manager.getGoodCounter().iterator();
				for(int i=1; it.hasNext(); i++){
					sb.append(i + "ڂŐ:\t" + it.next() + "\r\n");
				}
				taQuestion.setText(sb.toString());
				btnOK.setEnabled(false);
			}
		}
	}
	
	void checkAnswer(){
		if(problem == null){ return; }
		String answer = txtAnswer.getText();
		String correct = problem.getCorrectAnswerFor(answer);
		if(answer.equals(correct)){
			manager.solved(problem, failed);
			nextProblem();
			txtAnswer.setText("");
		}else{
			failed = true;
			int len = Manager.hitLength(answer, correct);
			len++;
			String hint;
			if(len >= correct.length()){
				hint = correct;
			}else{
				hint = correct.substring(0,len) + "...";
			}
			taQuestion.setText(problem.getQuestion() + "\r\n(" + hint + ")");
		}
	}
}
